# Copyright (c) 2012-2021, Mark Peek <mark@peek.org>
# All rights reserved.
#
# See LICENSE file for full license.

from typing import Optional

from .aws import Action as BaseAction
from .aws import BaseARN

service_name = "Amazon DataZone"
prefix = "datazone"


class Action(BaseAction):
    def __init__(self, action: Optional[str] = None) -> None:
        super().__init__(prefix, action)


class ARN(BaseARN):
    def __init__(self, resource: str = "", region: str = "", account: str = "") -> None:
        super().__init__(
            service=prefix, resource=resource, region=region, account=account
        )


AcceptPredictions = Action("AcceptPredictions")
AcceptSubscriptionRequest = Action("AcceptSubscriptionRequest")
CancelSubscription = Action("CancelSubscription")
CreateAsset = Action("CreateAsset")
CreateAssetRevision = Action("CreateAssetRevision")
CreateAssetType = Action("CreateAssetType")
CreateDataSource = Action("CreateDataSource")
CreateDomain = Action("CreateDomain")
CreateEnvironment = Action("CreateEnvironment")
CreateEnvironmentBlueprint = Action("CreateEnvironmentBlueprint")
CreateEnvironmentProfile = Action("CreateEnvironmentProfile")
CreateFormType = Action("CreateFormType")
CreateGlossary = Action("CreateGlossary")
CreateGlossaryTerm = Action("CreateGlossaryTerm")
CreateGroupProfile = Action("CreateGroupProfile")
CreateListingChangeSet = Action("CreateListingChangeSet")
CreateProject = Action("CreateProject")
CreateProjectMembership = Action("CreateProjectMembership")
CreateSubscriptionGrant = Action("CreateSubscriptionGrant")
CreateSubscriptionRequest = Action("CreateSubscriptionRequest")
CreateSubscriptionTarget = Action("CreateSubscriptionTarget")
CreateUserProfile = Action("CreateUserProfile")
DeleteAsset = Action("DeleteAsset")
DeleteAssetType = Action("DeleteAssetType")
DeleteDataSource = Action("DeleteDataSource")
DeleteDomain = Action("DeleteDomain")
DeleteDomainSharingPolicy = Action("DeleteDomainSharingPolicy")
DeleteEnvironment = Action("DeleteEnvironment")
DeleteEnvironmentBlueprint = Action("DeleteEnvironmentBlueprint")
DeleteEnvironmentBlueprintConfiguration = Action(
    "DeleteEnvironmentBlueprintConfiguration"
)
DeleteEnvironmentProfile = Action("DeleteEnvironmentProfile")
DeleteFormType = Action("DeleteFormType")
DeleteGlossary = Action("DeleteGlossary")
DeleteGlossaryTerm = Action("DeleteGlossaryTerm")
DeleteListing = Action("DeleteListing")
DeleteProject = Action("DeleteProject")
DeleteProjectMembership = Action("DeleteProjectMembership")
DeleteSubscriptionGrant = Action("DeleteSubscriptionGrant")
DeleteSubscriptionRequest = Action("DeleteSubscriptionRequest")
DeleteSubscriptionTarget = Action("DeleteSubscriptionTarget")
GetAsset = Action("GetAsset")
GetAssetType = Action("GetAssetType")
GetDataSource = Action("GetDataSource")
GetDataSourceRun = Action("GetDataSourceRun")
GetDomain = Action("GetDomain")
GetDomainSharingPolicy = Action("GetDomainSharingPolicy")
GetEnvironment = Action("GetEnvironment")
GetEnvironmentActionLink = Action("GetEnvironmentActionLink")
GetEnvironmentBlueprint = Action("GetEnvironmentBlueprint")
GetEnvironmentBlueprintConfiguration = Action("GetEnvironmentBlueprintConfiguration")
GetEnvironmentCredentials = Action("GetEnvironmentCredentials")
GetEnvironmentProfile = Action("GetEnvironmentProfile")
GetFormType = Action("GetFormType")
GetGlossary = Action("GetGlossary")
GetGlossaryTerm = Action("GetGlossaryTerm")
GetGroupProfile = Action("GetGroupProfile")
GetIamPortalLoginUrl = Action("GetIamPortalLoginUrl")
GetListing = Action("GetListing")
GetMetadataGenerationRun = Action("GetMetadataGenerationRun")
GetProject = Action("GetProject")
GetProjectConfiguration = Action("GetProjectConfiguration")
GetProjectCredentials = Action("GetProjectCredentials")
GetSubscription = Action("GetSubscription")
GetSubscriptionEligibility = Action("GetSubscriptionEligibility")
GetSubscriptionGrant = Action("GetSubscriptionGrant")
GetSubscriptionRequestDetails = Action("GetSubscriptionRequestDetails")
GetSubscriptionTarget = Action("GetSubscriptionTarget")
GetUserProfile = Action("GetUserProfile")
ListAccountEnvironments = Action("ListAccountEnvironments")
ListAssetRevisions = Action("ListAssetRevisions")
ListDataSourceRunActivities = Action("ListDataSourceRunActivities")
ListDataSourceRuns = Action("ListDataSourceRuns")
ListDataSources = Action("ListDataSources")
ListDomains = Action("ListDomains")
ListEnvironmentBlueprintConfigurations = Action(
    "ListEnvironmentBlueprintConfigurations"
)
ListEnvironmentBlueprints = Action("ListEnvironmentBlueprints")
ListEnvironmentProfiles = Action("ListEnvironmentProfiles")
ListEnvironments = Action("ListEnvironments")
ListGroupsForUser = Action("ListGroupsForUser")
ListMetadataGenerationRuns = Action("ListMetadataGenerationRuns")
ListNotifications = Action("ListNotifications")
ListProjectMemberships = Action("ListProjectMemberships")
ListProjects = Action("ListProjects")
ListSubscriptionGrants = Action("ListSubscriptionGrants")
ListSubscriptionRequests = Action("ListSubscriptionRequests")
ListSubscriptionTargets = Action("ListSubscriptionTargets")
ListSubscriptions = Action("ListSubscriptions")
ListTagsForResource = Action("ListTagsForResource")
ListUserProjects = Action("ListUserProjects")
ListWarehouseMetadata = Action("ListWarehouseMetadata")
ProvisionDomain = Action("ProvisionDomain")
PutDomainSharingPolicy = Action("PutDomainSharingPolicy")
PutEnvironmentBlueprintConfiguration = Action("PutEnvironmentBlueprintConfiguration")
RefreshToken = Action("RefreshToken")
RejectPredictions = Action("RejectPredictions")
RejectSubscriptionRequest = Action("RejectSubscriptionRequest")
RevokeSubscription = Action("RevokeSubscription")
Search = Action("Search")
SearchGroupProfiles = Action("SearchGroupProfiles")
SearchListings = Action("SearchListings")
SearchTypes = Action("SearchTypes")
SearchUserProfiles = Action("SearchUserProfiles")
SsoLogin = Action("SsoLogin")
SsoLogout = Action("SsoLogout")
StartDataSourceRun = Action("StartDataSourceRun")
StartMetadataGenerationRun = Action("StartMetadataGenerationRun")
StopMetadataGenerationRun = Action("StopMetadataGenerationRun")
TagResource = Action("TagResource")
UntagResource = Action("UntagResource")
UpdateDataSource = Action("UpdateDataSource")
UpdateDomain = Action("UpdateDomain")
UpdateEnvironment = Action("UpdateEnvironment")
UpdateEnvironmentBlueprint = Action("UpdateEnvironmentBlueprint")
UpdateEnvironmentConfiguration = Action("UpdateEnvironmentConfiguration")
UpdateEnvironmentDeploymentStatus = Action("UpdateEnvironmentDeploymentStatus")
UpdateEnvironmentProfile = Action("UpdateEnvironmentProfile")
UpdateGlossary = Action("UpdateGlossary")
UpdateGlossaryTerm = Action("UpdateGlossaryTerm")
UpdateGroupProfile = Action("UpdateGroupProfile")
UpdateProject = Action("UpdateProject")
UpdateSubscriptionGrantStatus = Action("UpdateSubscriptionGrantStatus")
UpdateSubscriptionRequest = Action("UpdateSubscriptionRequest")
UpdateSubscriptionTarget = Action("UpdateSubscriptionTarget")
UpdateUserProfile = Action("UpdateUserProfile")
ValidatePassRole = Action("ValidatePassRole")
