# Copyright (c) 2012-2021, Mark Peek <mark@peek.org>
# All rights reserved.
#
# See LICENSE file for full license.

from typing import Optional

from .aws import Action as BaseAction
from .aws import BaseARN

service_name = "Amazon SageMaker"
prefix = "sagemaker"


class Action(BaseAction):
    def __init__(self, action: Optional[str] = None) -> None:
        super().__init__(prefix, action)


class ARN(BaseARN):
    def __init__(self, resource: str = "", region: str = "", account: str = "") -> None:
        super().__init__(
            service=prefix, resource=resource, region=region, account=account
        )


AddAssociation = Action("AddAssociation")
AddTags = Action("AddTags")
AssociateTrialComponent = Action("AssociateTrialComponent")
BatchDescribeModelPackage = Action("BatchDescribeModelPackage")
BatchGetMetrics = Action("BatchGetMetrics")
BatchGetRecord = Action("BatchGetRecord")
BatchPutMetrics = Action("BatchPutMetrics")
CreateAction = Action("CreateAction")
CreateAlgorithm = Action("CreateAlgorithm")
CreateApp = Action("CreateApp")
CreateAppImageConfig = Action("CreateAppImageConfig")
CreateArtifact = Action("CreateArtifact")
CreateAutoMLJob = Action("CreateAutoMLJob")
CreateAutoMLJobV2 = Action("CreateAutoMLJobV2")
CreateCluster = Action("CreateCluster")
CreateCodeRepository = Action("CreateCodeRepository")
CreateCompilationJob = Action("CreateCompilationJob")
CreateContext = Action("CreateContext")
CreateDataQualityJobDefinition = Action("CreateDataQualityJobDefinition")
CreateDeviceFleet = Action("CreateDeviceFleet")
CreateDomain = Action("CreateDomain")
CreateEdgeDeploymentPlan = Action("CreateEdgeDeploymentPlan")
CreateEdgeDeploymentStage = Action("CreateEdgeDeploymentStage")
CreateEdgePackagingJob = Action("CreateEdgePackagingJob")
CreateEndpoint = Action("CreateEndpoint")
CreateEndpointConfig = Action("CreateEndpointConfig")
CreateExperiment = Action("CreateExperiment")
CreateFeatureGroup = Action("CreateFeatureGroup")
CreateFlowDefinition = Action("CreateFlowDefinition")
CreateHub = Action("CreateHub")
CreateHumanTaskUi = Action("CreateHumanTaskUi")
CreateHyperParameterTuningJob = Action("CreateHyperParameterTuningJob")
CreateImage = Action("CreateImage")
CreateImageVersion = Action("CreateImageVersion")
CreateInferenceComponent = Action("CreateInferenceComponent")
CreateInferenceExperiment = Action("CreateInferenceExperiment")
CreateInferenceRecommendationsJob = Action("CreateInferenceRecommendationsJob")
CreateLabelingJob = Action("CreateLabelingJob")
CreateLineageGroupPolicy = Action("CreateLineageGroupPolicy")
CreateModel = Action("CreateModel")
CreateModelBiasJobDefinition = Action("CreateModelBiasJobDefinition")
CreateModelCard = Action("CreateModelCard")
CreateModelCardExportJob = Action("CreateModelCardExportJob")
CreateModelExplainabilityJobDefinition = Action(
    "CreateModelExplainabilityJobDefinition"
)
CreateModelPackage = Action("CreateModelPackage")
CreateModelPackageGroup = Action("CreateModelPackageGroup")
CreateModelQualityJobDefinition = Action("CreateModelQualityJobDefinition")
CreateMonitoringSchedule = Action("CreateMonitoringSchedule")
CreateNotebookInstance = Action("CreateNotebookInstance")
CreateNotebookInstanceLifecycleConfig = Action("CreateNotebookInstanceLifecycleConfig")
CreatePipeline = Action("CreatePipeline")
CreatePresignedDomainUrl = Action("CreatePresignedDomainUrl")
CreatePresignedNotebookInstanceUrl = Action("CreatePresignedNotebookInstanceUrl")
CreateProcessingJob = Action("CreateProcessingJob")
CreateProject = Action("CreateProject")
CreateSharedModel = Action("CreateSharedModel")
CreateSpace = Action("CreateSpace")
CreateStudioLifecycleConfig = Action("CreateStudioLifecycleConfig")
CreateTrainingJob = Action("CreateTrainingJob")
CreateTransformJob = Action("CreateTransformJob")
CreateTrial = Action("CreateTrial")
CreateTrialComponent = Action("CreateTrialComponent")
CreateUserProfile = Action("CreateUserProfile")
CreateWorkforce = Action("CreateWorkforce")
CreateWorkteam = Action("CreateWorkteam")
DeleteAction = Action("DeleteAction")
DeleteAlgorithm = Action("DeleteAlgorithm")
DeleteApp = Action("DeleteApp")
DeleteAppImageConfig = Action("DeleteAppImageConfig")
DeleteArtifact = Action("DeleteArtifact")
DeleteAssociation = Action("DeleteAssociation")
DeleteCluster = Action("DeleteCluster")
DeleteCodeRepository = Action("DeleteCodeRepository")
DeleteContext = Action("DeleteContext")
DeleteDataQualityJobDefinition = Action("DeleteDataQualityJobDefinition")
DeleteDeviceFleet = Action("DeleteDeviceFleet")
DeleteDomain = Action("DeleteDomain")
DeleteEdgeDeploymentPlan = Action("DeleteEdgeDeploymentPlan")
DeleteEdgeDeploymentStage = Action("DeleteEdgeDeploymentStage")
DeleteEndpoint = Action("DeleteEndpoint")
DeleteEndpointConfig = Action("DeleteEndpointConfig")
DeleteExperiment = Action("DeleteExperiment")
DeleteFeatureGroup = Action("DeleteFeatureGroup")
DeleteFlowDefinition = Action("DeleteFlowDefinition")
DeleteHub = Action("DeleteHub")
DeleteHubContent = Action("DeleteHubContent")
DeleteHumanLoop = Action("DeleteHumanLoop")
DeleteHumanTaskUi = Action("DeleteHumanTaskUi")
DeleteImage = Action("DeleteImage")
DeleteImageVersion = Action("DeleteImageVersion")
DeleteInferenceComponent = Action("DeleteInferenceComponent")
DeleteInferenceExperiment = Action("DeleteInferenceExperiment")
DeleteLineageGroupPolicy = Action("DeleteLineageGroupPolicy")
DeleteModel = Action("DeleteModel")
DeleteModelBiasJobDefinition = Action("DeleteModelBiasJobDefinition")
DeleteModelCard = Action("DeleteModelCard")
DeleteModelExplainabilityJobDefinition = Action(
    "DeleteModelExplainabilityJobDefinition"
)
DeleteModelPackage = Action("DeleteModelPackage")
DeleteModelPackageGroup = Action("DeleteModelPackageGroup")
DeleteModelPackageGroupPolicy = Action("DeleteModelPackageGroupPolicy")
DeleteModelQualityJobDefinition = Action("DeleteModelQualityJobDefinition")
DeleteMonitoringSchedule = Action("DeleteMonitoringSchedule")
DeleteNotebookInstance = Action("DeleteNotebookInstance")
DeleteNotebookInstanceLifecycleConfig = Action("DeleteNotebookInstanceLifecycleConfig")
DeletePipeline = Action("DeletePipeline")
DeleteProject = Action("DeleteProject")
DeleteRecord = Action("DeleteRecord")
DeleteSpace = Action("DeleteSpace")
DeleteStudioLifecycleConfig = Action("DeleteStudioLifecycleConfig")
DeleteTags = Action("DeleteTags")
DeleteTrial = Action("DeleteTrial")
DeleteTrialComponent = Action("DeleteTrialComponent")
DeleteUserProfile = Action("DeleteUserProfile")
DeleteWorkforce = Action("DeleteWorkforce")
DeleteWorkteam = Action("DeleteWorkteam")
DeregisterDevices = Action("DeregisterDevices")
DescribeAction = Action("DescribeAction")
DescribeAlgorithm = Action("DescribeAlgorithm")
DescribeApp = Action("DescribeApp")
DescribeAppImageConfig = Action("DescribeAppImageConfig")
DescribeArtifact = Action("DescribeArtifact")
DescribeAutoMLJob = Action("DescribeAutoMLJob")
DescribeAutoMLJobV2 = Action("DescribeAutoMLJobV2")
DescribeCluster = Action("DescribeCluster")
DescribeClusterNode = Action("DescribeClusterNode")
DescribeCodeRepository = Action("DescribeCodeRepository")
DescribeCompilationJob = Action("DescribeCompilationJob")
DescribeContext = Action("DescribeContext")
DescribeDataQualityJobDefinition = Action("DescribeDataQualityJobDefinition")
DescribeDevice = Action("DescribeDevice")
DescribeDeviceFleet = Action("DescribeDeviceFleet")
DescribeDomain = Action("DescribeDomain")
DescribeEdgeDeploymentPlan = Action("DescribeEdgeDeploymentPlan")
DescribeEdgePackagingJob = Action("DescribeEdgePackagingJob")
DescribeEndpoint = Action("DescribeEndpoint")
DescribeEndpointConfig = Action("DescribeEndpointConfig")
DescribeExperiment = Action("DescribeExperiment")
DescribeFeatureGroup = Action("DescribeFeatureGroup")
DescribeFeatureMetadata = Action("DescribeFeatureMetadata")
DescribeFlowDefinition = Action("DescribeFlowDefinition")
DescribeHub = Action("DescribeHub")
DescribeHubContent = Action("DescribeHubContent")
DescribeHumanLoop = Action("DescribeHumanLoop")
DescribeHumanTaskUi = Action("DescribeHumanTaskUi")
DescribeHyperParameterTuningJob = Action("DescribeHyperParameterTuningJob")
DescribeImage = Action("DescribeImage")
DescribeImageVersion = Action("DescribeImageVersion")
DescribeInferenceComponent = Action("DescribeInferenceComponent")
DescribeInferenceExperiment = Action("DescribeInferenceExperiment")
DescribeInferenceRecommendationsJob = Action("DescribeInferenceRecommendationsJob")
DescribeLabelingJob = Action("DescribeLabelingJob")
DescribeLineageGroup = Action("DescribeLineageGroup")
DescribeModel = Action("DescribeModel")
DescribeModelBiasJobDefinition = Action("DescribeModelBiasJobDefinition")
DescribeModelCard = Action("DescribeModelCard")
DescribeModelCardExportJob = Action("DescribeModelCardExportJob")
DescribeModelExplainabilityJobDefinition = Action(
    "DescribeModelExplainabilityJobDefinition"
)
DescribeModelPackage = Action("DescribeModelPackage")
DescribeModelPackageGroup = Action("DescribeModelPackageGroup")
DescribeModelQualityJobDefinition = Action("DescribeModelQualityJobDefinition")
DescribeMonitoringSchedule = Action("DescribeMonitoringSchedule")
DescribeNotebookInstance = Action("DescribeNotebookInstance")
DescribeNotebookInstanceLifecycleConfig = Action(
    "DescribeNotebookInstanceLifecycleConfig"
)
DescribePipeline = Action("DescribePipeline")
DescribePipelineDefinitionForExecution = Action(
    "DescribePipelineDefinitionForExecution"
)
DescribePipelineExecution = Action("DescribePipelineExecution")
DescribeProcessingJob = Action("DescribeProcessingJob")
DescribeProject = Action("DescribeProject")
DescribeSharedModel = Action("DescribeSharedModel")
DescribeSpace = Action("DescribeSpace")
DescribeStudioLifecycleConfig = Action("DescribeStudioLifecycleConfig")
DescribeSubscribedWorkteam = Action("DescribeSubscribedWorkteam")
DescribeTrainingJob = Action("DescribeTrainingJob")
DescribeTransformJob = Action("DescribeTransformJob")
DescribeTrial = Action("DescribeTrial")
DescribeTrialComponent = Action("DescribeTrialComponent")
DescribeUserProfile = Action("DescribeUserProfile")
DescribeWorkforce = Action("DescribeWorkforce")
DescribeWorkteam = Action("DescribeWorkteam")
DisableSagemakerServicecatalogPortfolio = Action(
    "DisableSagemakerServicecatalogPortfolio"
)
DisassociateTrialComponent = Action("DisassociateTrialComponent")
EnableSagemakerServicecatalogPortfolio = Action(
    "EnableSagemakerServicecatalogPortfolio"
)
GetDeployments = Action("GetDeployments")
GetDeviceFleetReport = Action("GetDeviceFleetReport")
GetDeviceRegistration = Action("GetDeviceRegistration")
GetLineageGroupPolicy = Action("GetLineageGroupPolicy")
GetModelPackageGroupPolicy = Action("GetModelPackageGroupPolicy")
GetRecord = Action("GetRecord")
GetSagemakerServicecatalogPortfolioStatus = Action(
    "GetSagemakerServicecatalogPortfolioStatus"
)
GetScalingConfigurationRecommendation = Action("GetScalingConfigurationRecommendation")
GetScalingPolicyConfigurationRecommendation = Action(
    "GetScalingPolicyConfigurationRecommendation"
)
GetSearchSuggestions = Action("GetSearchSuggestions")
ImportHubContent = Action("ImportHubContent")
InvokeEndpoint = Action("InvokeEndpoint")
InvokeEndpointAsync = Action("InvokeEndpointAsync")
InvokeEndpointWithResponseStream = Action("InvokeEndpointWithResponseStream")
ListActions = Action("ListActions")
ListAlgorithms = Action("ListAlgorithms")
ListAliases = Action("ListAliases")
ListAppImageConfigs = Action("ListAppImageConfigs")
ListApps = Action("ListApps")
ListArtifacts = Action("ListArtifacts")
ListAssociations = Action("ListAssociations")
ListAutoMLJobs = Action("ListAutoMLJobs")
ListCandidatesForAutoMLJob = Action("ListCandidatesForAutoMLJob")
ListClusterNodes = Action("ListClusterNodes")
ListClusters = Action("ListClusters")
ListCodeRepositories = Action("ListCodeRepositories")
ListCompilationJobs = Action("ListCompilationJobs")
ListContexts = Action("ListContexts")
ListDataQualityJobDefinitions = Action("ListDataQualityJobDefinitions")
ListDeviceFleets = Action("ListDeviceFleets")
ListDevices = Action("ListDevices")
ListDomains = Action("ListDomains")
ListEdgeDeploymentPlans = Action("ListEdgeDeploymentPlans")
ListEdgePackagingJobs = Action("ListEdgePackagingJobs")
ListEndpointConfigs = Action("ListEndpointConfigs")
ListEndpoints = Action("ListEndpoints")
ListExperiments = Action("ListExperiments")
ListFeatureGroups = Action("ListFeatureGroups")
ListFlowDefinitions = Action("ListFlowDefinitions")
ListHubContentVersions = Action("ListHubContentVersions")
ListHubContents = Action("ListHubContents")
ListHubs = Action("ListHubs")
ListHumanLoops = Action("ListHumanLoops")
ListHumanTaskUis = Action("ListHumanTaskUis")
ListHyperParameterTuningJobs = Action("ListHyperParameterTuningJobs")
ListImageVersions = Action("ListImageVersions")
ListImages = Action("ListImages")
ListInferenceComponents = Action("ListInferenceComponents")
ListInferenceExperiments = Action("ListInferenceExperiments")
ListInferenceRecommendationsJobSteps = Action("ListInferenceRecommendationsJobSteps")
ListInferenceRecommendationsJobs = Action("ListInferenceRecommendationsJobs")
ListLabelingJobs = Action("ListLabelingJobs")
ListLabelingJobsForWorkteam = Action("ListLabelingJobsForWorkteam")
ListLineageGroups = Action("ListLineageGroups")
ListModelBiasJobDefinitions = Action("ListModelBiasJobDefinitions")
ListModelCardExportJobs = Action("ListModelCardExportJobs")
ListModelCardVersions = Action("ListModelCardVersions")
ListModelCards = Action("ListModelCards")
ListModelExplainabilityJobDefinitions = Action("ListModelExplainabilityJobDefinitions")
ListModelMetadata = Action("ListModelMetadata")
ListModelPackageGroups = Action("ListModelPackageGroups")
ListModelPackages = Action("ListModelPackages")
ListModelQualityJobDefinitions = Action("ListModelQualityJobDefinitions")
ListModels = Action("ListModels")
ListMonitoringAlertHistory = Action("ListMonitoringAlertHistory")
ListMonitoringAlerts = Action("ListMonitoringAlerts")
ListMonitoringExecutions = Action("ListMonitoringExecutions")
ListMonitoringSchedules = Action("ListMonitoringSchedules")
ListNotebookInstanceLifecycleConfigs = Action("ListNotebookInstanceLifecycleConfigs")
ListNotebookInstances = Action("ListNotebookInstances")
ListPipelineExecutionSteps = Action("ListPipelineExecutionSteps")
ListPipelineExecutions = Action("ListPipelineExecutions")
ListPipelineParametersForExecution = Action("ListPipelineParametersForExecution")
ListPipelines = Action("ListPipelines")
ListProcessingJobs = Action("ListProcessingJobs")
ListProjects = Action("ListProjects")
ListResourceCatalogs = Action("ListResourceCatalogs")
ListSharedModelEvents = Action("ListSharedModelEvents")
ListSharedModelVersions = Action("ListSharedModelVersions")
ListSharedModels = Action("ListSharedModels")
ListSpaces = Action("ListSpaces")
ListStageDevices = Action("ListStageDevices")
ListStudioLifecycleConfigs = Action("ListStudioLifecycleConfigs")
ListSubscribedWorkteams = Action("ListSubscribedWorkteams")
ListTags = Action("ListTags")
ListTrainingJobs = Action("ListTrainingJobs")
ListTrainingJobsForHyperParameterTuningJob = Action(
    "ListTrainingJobsForHyperParameterTuningJob"
)
ListTransformJobs = Action("ListTransformJobs")
ListTrialComponents = Action("ListTrialComponents")
ListTrials = Action("ListTrials")
ListUserProfiles = Action("ListUserProfiles")
ListWorkforces = Action("ListWorkforces")
ListWorkteams = Action("ListWorkteams")
PutLineageGroupPolicy = Action("PutLineageGroupPolicy")
PutModelPackageGroupPolicy = Action("PutModelPackageGroupPolicy")
PutRecord = Action("PutRecord")
QueryLineage = Action("QueryLineage")
RegisterDevices = Action("RegisterDevices")
RenderUiTemplate = Action("RenderUiTemplate")
RetryPipelineExecution = Action("RetryPipelineExecution")
Search = Action("Search")
SendHeartbeat = Action("SendHeartbeat")
SendPipelineExecutionStepFailure = Action("SendPipelineExecutionStepFailure")
SendPipelineExecutionStepSuccess = Action("SendPipelineExecutionStepSuccess")
SendSharedModelEvent = Action("SendSharedModelEvent")
StartEdgeDeploymentStage = Action("StartEdgeDeploymentStage")
StartHumanLoop = Action("StartHumanLoop")
StartInferenceExperiment = Action("StartInferenceExperiment")
StartMonitoringSchedule = Action("StartMonitoringSchedule")
StartNotebookInstance = Action("StartNotebookInstance")
StartPipelineExecution = Action("StartPipelineExecution")
StopAutoMLJob = Action("StopAutoMLJob")
StopCompilationJob = Action("StopCompilationJob")
StopEdgeDeploymentStage = Action("StopEdgeDeploymentStage")
StopEdgePackagingJob = Action("StopEdgePackagingJob")
StopHumanLoop = Action("StopHumanLoop")
StopHyperParameterTuningJob = Action("StopHyperParameterTuningJob")
StopInferenceExperiment = Action("StopInferenceExperiment")
StopInferenceRecommendationsJob = Action("StopInferenceRecommendationsJob")
StopLabelingJob = Action("StopLabelingJob")
StopMonitoringSchedule = Action("StopMonitoringSchedule")
StopNotebookInstance = Action("StopNotebookInstance")
StopPipelineExecution = Action("StopPipelineExecution")
StopProcessingJob = Action("StopProcessingJob")
StopTrainingJob = Action("StopTrainingJob")
StopTransformJob = Action("StopTransformJob")
UpdateAction = Action("UpdateAction")
UpdateAppImageConfig = Action("UpdateAppImageConfig")
UpdateArtifact = Action("UpdateArtifact")
UpdateCluster = Action("UpdateCluster")
UpdateCodeRepository = Action("UpdateCodeRepository")
UpdateContext = Action("UpdateContext")
UpdateDeviceFleet = Action("UpdateDeviceFleet")
UpdateDevices = Action("UpdateDevices")
UpdateDomain = Action("UpdateDomain")
UpdateEndpoint = Action("UpdateEndpoint")
UpdateEndpointWeightsAndCapacities = Action("UpdateEndpointWeightsAndCapacities")
UpdateExperiment = Action("UpdateExperiment")
UpdateFeatureGroup = Action("UpdateFeatureGroup")
UpdateFeatureMetadata = Action("UpdateFeatureMetadata")
UpdateHub = Action("UpdateHub")
UpdateImage = Action("UpdateImage")
UpdateImageVersion = Action("UpdateImageVersion")
UpdateInferenceComponent = Action("UpdateInferenceComponent")
UpdateInferenceComponentRuntimeConfig = Action("UpdateInferenceComponentRuntimeConfig")
UpdateInferenceExperiment = Action("UpdateInferenceExperiment")
UpdateModelCard = Action("UpdateModelCard")
UpdateModelPackage = Action("UpdateModelPackage")
UpdateMonitoringAlert = Action("UpdateMonitoringAlert")
UpdateMonitoringSchedule = Action("UpdateMonitoringSchedule")
UpdateNotebookInstance = Action("UpdateNotebookInstance")
UpdateNotebookInstanceLifecycleConfig = Action("UpdateNotebookInstanceLifecycleConfig")
UpdatePipeline = Action("UpdatePipeline")
UpdatePipelineExecution = Action("UpdatePipelineExecution")
UpdateProject = Action("UpdateProject")
UpdateSharedModel = Action("UpdateSharedModel")
UpdateSpace = Action("UpdateSpace")
UpdateTrainingJob = Action("UpdateTrainingJob")
UpdateTrial = Action("UpdateTrial")
UpdateTrialComponent = Action("UpdateTrialComponent")
UpdateUserProfile = Action("UpdateUserProfile")
UpdateWorkforce = Action("UpdateWorkforce")
UpdateWorkteam = Action("UpdateWorkteam")
